std::atomic< bool > Struct Reference
Atomics

`#include <atomic>`

## Public Types

using | value_type

## Public Member Functions

constexpr | atomic (bool __i) noexcept
| atomic (const atomic &)=delete
bool | compare_exchange_strong (bool &__i1, bool __i2, memory_order __m1, memory_order __m2) noexcept
bool | compare_exchange_strong (bool &__i1, bool __i2, memory_order __m1, memory_order __m2) volatile noexcept
bool | compare_exchange_strong (bool &__i1, bool __i2, memory_order __m=memory_order_seq_cst) noexcept
bool | compare_exchange_strong (bool &__i1, bool __i2, memory_order __m=memory_order_seq_cst) volatile noexcept
bool | compare_exchange_weak (bool &__i1, bool __i2, memory_order __m1, memory_order __m2) noexcept
bool | compare_exchange_weak (bool &__i1, bool __i2, memory_order __m1, memory_order __m2) volatile noexcept
bool | compare_exchange_weak (bool &__i1, bool __i2, memory_order __m=memory_order_seq_cst) noexcept
bool | compare_exchange_weak (bool &__i1, bool __i2, memory_order __m=memory_order_seq_cst) volatile noexcept
bool | exchange (bool __i, memory_order __m=memory_order_seq_cst) noexcept
bool | exchange (bool __i, memory_order __m=memory_order_seq_cst) volatile noexcept
bool | is_lock_free () const noexcept
bool | is_lock_free () const volatile noexcept
bool | load (memory_order __m=memory_order_seq_cst) const noexcept
bool | load (memory_order __m=memory_order_seq_cst) const volatile noexcept
void | notify_all () noexcept
void | notify_one () noexcept
| operator bool () const noexcept
| operator bool () const noexcept
| operator bool () const volatile noexcept
| operator bool () const volatile noexcept
bool | operator= (bool __i) noexcept
bool | operator= (bool __i) volatile noexcept
atomic & | operator= (const atomic &) volatile =delete
atomic & | operator= (const atomic &)=delete
void | store (bool __i, memory_order __m=memory_order_seq_cst) noexcept
void | store (bool __i, memory_order __m=memory_order_seq_cst) volatile noexcept
void | wait (bool __old, memory_order __m=memory_order_seq_cst) const noexcept

## Static Public Attributes

static constexpr bool | is_always_lock_free

## Detailed Description

atomic<bool>

Definition at line 62 of file atomic.

## Member Typedef Documentation

## value_type

using std::atomic< bool >::value_type

Definition at line 64 of file atomic.

## Constructor & Destructor Documentation

## atomic()

std::atomic< bool >::atomic | ( | bool | __i | ) |

inline constexpr noexcept

Definition at line 76 of file atomic.

## Member Function Documentation

## compare_exchange_strong() [1/4]

bool std::atomic< bool >::compare_exchange_strong | ( | bool & | __i1,
|  | bool | __i2,
|  | memory_order | __m1,
|  | memory_order | __m2 )

inline noexcept

Definition at line 148 of file atomic.

## compare_exchange_strong() [2/4]

bool std::atomic< bool >::compare_exchange_strong | ( | bool & | __i1,
|  | bool | __i2,
|  | memory_order | __m1,
|  | memory_order | __m2 ) volatile

inline noexcept

Definition at line 153 of file atomic.

## compare_exchange_strong() [3/4]

bool std::atomic< bool >::compare_exchange_strong | ( | bool & | __i1,
|  | bool | __i2,
|  | memory_order | __m = memory_order_seq_cst )

inline noexcept

Definition at line 158 of file atomic.

## compare_exchange_strong() [4/4]

bool std::atomic< bool >::compare_exchange_strong | ( | bool & | __i1,
|  | bool | __i2,
|  | memory_order | __m = memory_order_seq_cst ) volatile

inline noexcept

Definition at line 163 of file atomic.

## compare_exchange_weak() [1/4]

bool std::atomic< bool >::compare_exchange_weak | ( | bool & | __i1,
|  | bool | __i2,
|  | memory_order | __m1,
|  | memory_order | __m2 )

inline noexcept

Definition at line 128 of file atomic.

## compare_exchange_weak() [2/4]

bool std::atomic< bool >::compare_exchange_weak | ( | bool & | __i1,
|  | bool | __i2,
|  | memory_order | __m1,
|  | memory_order | __m2 ) volatile

inline noexcept

Definition at line 133 of file atomic.

## compare_exchange_weak() [3/4]

bool std::atomic< bool >::compare_exchange_weak | ( | bool & | __i1,
|  | bool | __i2,
|  | memory_order | __m = memory_order_seq_cst )

inline noexcept

Definition at line 138 of file atomic.

## compare_exchange_weak() [4/4]

bool std::atomic< bool >::compare_exchange_weak | ( | bool & | __i1,
|  | bool | __i2,
|  | memory_order | __m = memory_order_seq_cst ) volatile

inline noexcept

Definition at line 143 of file atomic.

## exchange() [1/2]

bool std::atomic< bool >::exchange | ( | bool | __i,
|  | memory_order | __m = memory_order_seq_cst )

inline noexcept

Definition at line 119 of file atomic.

## exchange() [2/2]

bool std::atomic< bool >::exchange | ( | bool | __i,
|  | memory_order | __m = memory_order_seq_cst ) volatile

inline noexcept

Definition at line 123 of file atomic.

## is_lock_free() [1/2]

bool std::atomic< bool >::is_lock_free | ( |  | ) | const

inline noexcept

Definition at line 93 of file atomic.

## is_lock_free() [2/2]

bool std::atomic< bool >::is_lock_free | ( |  | ) | const volatile

inline noexcept

Definition at line 96 of file atomic.

## load() [1/2]

bool std::atomic< bool >::load | ( | memory_order | __m = memory_order_seq_cst | ) | const

inline noexcept

Definition at line 111 of file atomic.

## load() [2/2]

bool std::atomic< bool >::load | ( | memory_order | __m = memory_order_seq_cst | ) | const volatile

inline noexcept

Definition at line 115 of file atomic.

## notify_all()

void std::atomic< bool >::notify_all | ( |  | ) |

inline noexcept

Definition at line 179 of file atomic.

## notify_one()

void std::atomic< bool >::notify_one | ( |  | ) |

inline noexcept

Definition at line 175 of file atomic.

## operator bool() [1/4]

std::atomic< bool >::operator bool | ( |  | ) | const

inline noexcept

Definition at line 245 of file atomic.

## operator bool() [2/4]

std::atomic< bool >::operator bool | ( |  | ) | const

inline noexcept

Definition at line 86 of file atomic.

## operator bool() [3/4]

std::atomic< bool >::operator bool | ( |  | ) | const volatile

inline noexcept

Definition at line 248 of file atomic.

## operator bool() [4/4]

std::atomic< bool >::operator bool | ( |  | ) | const volatile

inline noexcept

Definition at line 89 of file atomic.

## operator=() [1/2]

bool std::atomic< bool >::operator= | ( | bool | __i | ) |

inline noexcept

Definition at line 79 of file atomic.

## operator=() [2/2]

bool std::atomic< bool >::operator= | ( | bool | __i | ) | volatile

inline noexcept

Definition at line 83 of file atomic.

## store() [1/2]

void std::atomic< bool >::store | ( | bool | __i,
|  | memory_order | __m = memory_order_seq_cst )

inline noexcept

Definition at line 103 of file atomic.

## store() [2/2]

void std::atomic< bool >::store | ( | bool | __i,
|  | memory_order | __m = memory_order_seq_cst ) volatile

inline noexcept

Definition at line 107 of file atomic.

## wait()

void std::atomic< bool >::wait | ( | bool | __old,
|  | memory_order | __m = memory_order_seq_cst ) const

inline noexcept

Definition at line 169 of file atomic.

## Member Data Documentation

## is_always_lock_free

bool std::atomic< bool >::is_always_lock_free

static constexpr

Definition at line 99 of file atomic.

The documentation for this struct was generated from the following file:

- atomic